/* 2005-12-17 programmeerimisvistlus                                      */
/* lesanne: ARVUTIPOOD, kergem variant                                    */
/* Autor: Ahto Truu                                                        */
/* Testitud: GCC 3.2.3 / MinGW                                             */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define SISF "apood.sis"                               /* sisendfaili nimi */
#define VALF "apood.val"                              /* vljundfaili nimi */
#define MAXN 10000                             /* maksimaalne arvutite arv */

typedef struct {                                      /* he arvuti andmed */
  int h, p, m, k, v;
} ARVUTI;

FILE *f;                            /* failimuutuja sisendi/vljundi jaoks */

int n;                                             /* arvutite tegelik arv */
ARVUTI a[MAXN];                                         /* arvutite andmed */

char t[4];                            /* tingimuse parameeter ja operaator */
int v;                                           /* parameetri piirvrtus */

int m;                               /* tingimust rahuldavate arvutite arv */
int x[MAXN];                              /* ja nende indeksid massiivis a */

int main() {
    int i;

    /* loeme sisendandmed */
    f = fopen(SISF, "rt");
    fscanf(f, "%d ", &n);                                  /* arvutite arv */
    for (i = 0; i < n; ++i)                        /* arvutite parameetrid */
        fscanf(f, "%d %d %d %d %d ",
            &a[i].h, &a[i].p, &a[i].m, &a[i].k, &a[i].v);
    fscanf(f, "%c%c%c%c %d ", &t[0], &t[1], &t[2], &t[3], &v);  /* tingimus */
    fclose(f);

    /* leiame vastuse */
    m = 0;
    for (i = 0; i < n; ++i) {
        /* kontrollime kshaaval vimalikke tingimusi */
        if (strncmp(t, "H =<", 4) == 0)
            if (a[i].h <= v)
                x[m++] = i;
        if (strncmp(t, "H >=", 4) == 0)
            if (a[i].h >= v)
                x[m++] = i;
        if (strncmp(t, "P =<", 4) == 0)
            if (a[i].p <= v)
                x[m++] = i;
        if (strncmp(t, "P >=", 4) == 0)
            if (a[i].p >= v)
                x[m++] = i;
        if (strncmp(t, "M =<", 4) == 0)
            if (a[i].m <= v)
                x[m++] = i;
        if (strncmp(t, "M >=", 4) == 0)
            if (a[i].m >= v)
                x[m++] = i;
        if (strncmp(t, "K =<", 4) == 0)
            if (a[i].k <= v)
                x[m++] = i;
        if (strncmp(t, "K >=", 4) == 0)
            if (a[i].k >= v)
                x[m++] = i;
        if (strncmp(t, "V =<", 4) == 0)
            if (a[i].v <= v)
                x[m++] = i;
        if (strncmp(t, "V >=", 4) == 0)
            if (a[i].v >= v)
                x[m++] = i;
    }

    /* vljastame */
    f = fopen(VALF, "wt");
    if (m == 0)
        fprintf(f, "%s\n", "EI OLE");
    else {
        fprintf(f, "%d\n", m);
        for (i = 0; i < m; ++i)
            fprintf(f, "%d %d %d %d %d\n",
                a[x[i]].h, a[x[i]].p, a[x[i]].m, a[x[i]].k, a[x[i]].v);
    }
    fclose(f);

    return 0;
}
