{ 2005-12-17 programmeerimisvistlus                                        }
{ lesanne: SULGAVALDISED                                                   }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 2.0.0 / Win32                                               }

const
   sisf = 'sulud.sis';                                   { sisendfaili nimi }
   valf = 'sulud.val';                                  { vljundfaili nimi }
   maxn = 20;                                 { maksimaalne avaldise pikkus }

type                                        { lihtahel avaldiste hoidmiseks }
   viit = ^elem;
   elem = record
      a : string[maxn];                                       { avaldis ise }
      v : viit;                                { viit jrgmisele elemendile }
   end;

{ lisab uue avaldise antud ahelasse }
{ efektiivsuse huvides lisab kirje ahela algusse }
procedure lisa(var v : viit; s : string);
var w : viit;
begin
   new(w);                                                { teeme uue kirje }
   w^.a := s;                                         { salvestame avaldise }
   w^.v := v;                   { endine ahela esimene on nd uue jrgmine }
   v := w;                               { ja uus on nd ise ahela esimene }
end;

var
   f : text;                          { failimuutuja sisendi/vljundi jaoks }
   m : integer;                                            { avaldiste tp }
   n : integer;                                           { avaldise pikkus }
   liht, koik : array [0..maxn] of viit;         { avaldised pikkuste kaupa }
   v, w : viit;
   i, k : integer;

begin
   assign(f, sisf); reset(f);
   readln(f, m);
   readln(f, n);
   close(f);

   i := 0;
   liht[i] := nil; lisa(liht[i], '');
   koik[i] := liht[i];
   while i < n do begin
      i := i + 2;
      { lihtavaldised: kigile lhematele avaldistele sulud mber }
      liht[i] := nil;
      v := koik[i - 2];
      while v <> nil do begin
         if m > 0 then
            lisa(liht[i], '(' + v^.a + ')');
         if m > 1 then
            lisa(liht[i], '[' + v^.a + ']');
         if m > 2 then
            lisa(liht[i], '{' + v^.a + '}');
         v := v ^.v;
      end;
      { lihtavaldis on avaldise erijuht }
      koik[i] := liht[i];
      { lisaks kigile lhematele avaldistele lhemad lihtavaldised otsa }
      k := 2;
      while k < i do begin
         v := koik[k];
         while v <> nil do begin
            w := liht[i - k];
            while w <> nil do begin
               lisa(koik[i], v^.a + w^.a);
               w := w^.v;
            end;
            v := v^.v;
         end;
         k := k + 2;
      end;
   end;

   assign(f, valf); rewrite(f);
   v := koik[n];
   while v <> nil do begin
      writeln(f, v^.a);
      v := v^.v;
   end;
   close(f);

   { teoreetiliselt oleks viisakas ka mlu vabastada }
   { aga praktiliselt teeb opssteem seda meie eest }
end.
