#include <cstdio>
#include <cstdlib>
#include <cstring>

const char *IN = "summa.sis";
const char *OUT = "summa.val";
const char *HINT = "summa.xxx";

void ERR(const char *s) {
    printf("400\nError: %s\n", s);
    exit(0);
}

void OK(int n, const char *s) {
    printf("200\nScore: %d\nError: %s\n", n, s);
    exit(0);
}

char *trim(char *s) {
    int i = strlen(s) - 1;
    while (i >= 0 && (s[i] == '\n' || s[i] == '\r'))
        s[i--] = 0;
    return s;
}

char s1[500];
char s2[500];

int main() {
    FILE *out = fopen(OUT, "rt");
    if (!out)
        ERR("Viga vljundfaili avamisel");
    if (!fgets(s1, sizeof(s1), out))
        OK(0, "Enneaegne faili lpp");
    if (fscanf(out, "%10s", s2) == 1)
        OK(0, "Liigsed read faili lpus");
    if (fclose(out))
        ERR("Viga vljundfaili sulgemisel");
    trim(s1);

    bool ok = false;
    FILE *hint = fopen(HINT, "rt");
    if (!hint)
        ERR("Viga vihjefaili avamisel");
    while (fgets(s2, sizeof(s2), hint))
        if (strcmp(s1, trim(s2)) == 0) {
            ok = true;
            break;
        }
    if (fclose(hint))
        ERR("Viga vihjefaili sulgemisel");

    if (!ok) 
        OK(0, "Vale vastus");
    OK(100, "OK");
}
