#include <cstdio>
#include <cstdlib>
#include <cstring>

const char *IN = "klots.sis";
const char *OUT = "klots.val";

void ERR(const char *s) {
    printf("400\nError: %s\n", s);
    exit(0);
}

void OK(int n, const char *s) {
    printf("200\nScore: %d\nError: %s\n", n, s);
    exit(0);
}

int n, r, v;
int m1, m2;

int main() {
    FILE *in = fopen(IN, "rt");
    if (!in)
        ERR("Viga sisendfaili avamisel");
    if (fscanf(in, "%d %d %d", &n, &r, &v) != 3)
        ERR("Viga sisendfaili lugemisel");
    if (fclose(in))
        ERR("Viga sisendfaili sulgemisel");

    // lahendame lesande
    m1 = 0;
    --r; --v;
    for (int i = n; i > 0; --i) {
        if (r % 3 == 1 && v % 3 == 1)
            m1 = n - i + 1;
        r /= 3; v /= 3;
    }

    FILE *out = fopen(OUT, "rt");
    if (!out)
        ERR("Viga vljundfaili avamisel");
    char s[20];
    int u;
    if (!fgets(s, sizeof(s), out))
        OK(0, "Enneaegne faili lpp");
    if (sscanf(s, "%d %n", &m2, &u) != 1)
        OK(0, "Viga tisarvu lugemisel");
    if (u < strlen(s))
        OK(0, "Liigsed smbolid rea lpus");
    if (fscanf(out, "%10s", s) == 1)
        OK(0, "Liigsed read faili lpus");
    if (fclose(out))
        ERR("Viga vljundfaili sulgemisel");

    if (m1 != m2)
        OK(0, "Vale vastus");
    OK(100, "OK");
}
